﻿using System;

namespace AbstractFactory
{
    class Tester
    {
        IMakeCamera[] factories = new IMakeCamera[2];
        public Tester()
        {
            Initialize();
        }
        public void Test()
        {
            TestDirect();
            TestUsingFactory();
        }

        private void TestUsingFactory()
        {
            Camera camera = null;
            ITake lens = null;
            foreach (IMakeCamera factory in factories)
            {
                camera = factory.MakeCamera();
                lens = factory.MakeLens();
                TestCase(camera, lens);

            }            
        }

        private void TestDirect()
        {
            Camera camera = new EvCamera();
            ITake lens = new HoLens();
            TestCase(camera,lens);            
        }

        private void TestCase(Camera camera, ITake lens)
        {
            Console.WriteLine("테스트");
            if (camera.PutInLens(lens) == false)
            {
                Console.WriteLine("카메라에 렌즈가 장착이 되지 않았음");
            }
            if (camera.TakeAPicture() == false)
            {
                Console.WriteLine("사진이 찍히지 않았습니다.");
            }            
        }

        private void Initialize()
        {
            factories[0] = new EvDayFactory();
            factories[1] = new HoDayFactory();
        }

    }
}
